%%	Initial settings
Fs = 8000;
length = 1/8;
outCols = 16;

padsize = outCols - mod(Fs * length, outCols);

%%	Calculate frequencies
F1 = Fs/4;
F2 = Fs/8;
F3 = Fs/16;
F4 = Fs/32;
F5 = Fs/64;

%%	Make sample timer
t = 0:1/Fs:length - 1/Fs;

%%	Generate sine waves
S1 = sin(2 * pi * F1 * t);
S2 = sin(2 * pi * F2 * t);
S3 = sin(2 * pi * F3 * t);
S4 = sin(2 * pi * F4 * t);
S5 = sin(2 * pi * F5 * t);

%%	Mix and normalise sine waves
signal = S1 + S2 + S3 + S4 + S5;
signal = signal ./ abs(max(signal));

%%	Export signal
output = int16(signal * 2^15);
output = padarray(output, [0 8], 'post');
output = reshape(output, outCols, [])';
dlmwrite('out.txt', output, ',');