/*
 * WriteRaw.c
 * 
 * Copyright 2014 Rune Bjønnum <rune@bjonnum.no>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */


#include <stdio.h>
#include <windows.h>
#include <stdint.h>
#include "data.h"

int main(int argc, char **argv)
{
	HANDLE					hFile;
	DWORD					dwBytesWritten;
	int						intLength = 0;
	
	//	Argument check
	if (argc != 2 && argc != 3)
	{
		fprintf(stderr, "Usage: %s <filename> <length>\n", argv[0]);
		ExitProcess(1);
	}
	
	if (argc == 3)
	{
		intLength = atoi(argv[2]);
		printf("Length: %d\n", intLength);
	}
	
	if (intLength == 0 || intLength > sizeof(srcSamples))
		intLength = sizeof(srcSamples);
	
	//	Try to open file
	if ((hFile = CreateFile(argv[1], GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		fprintf(stderr, "%s: unable to open file '%s'\n", argv[0], argv[1]);
		ExitProcess(1);
	}
	
	//	Write file
	if (!WriteFile(hFile, srcSamples, intLength, &dwBytesWritten, NULL))
	{
		fprintf(stderr, "%s: unable to write to file '%s'\n", argv[0], argv[1]);
		ExitProcess(1);
	}
	
	return 0;
}
